using System;

namespace CustomBandObjectLib
{
	/// <summary>
	/// Summary description for Favorites.
	/// </summary>
	public class Favorite
	{
		private bool cookie;
		private bool dwnLoad;
		private string URL;
		private string trigger;

		public Favorite(string cookie, string dwnLoad, string URL, string trigger)
		{
			if(cookie =="1")
			{
				Cookie = true;
			}
			else
			{
				Cookie = false;
			}
			
			if(dwnLoad =="1")
			{
				DownLoad = true;
			}
			else
			{
				DownLoad = false;
			}

			Url = URL;
			Trigger = trigger;
		}

		public bool Cookie
		{
			get{ return this.cookie;}
			set
			{ 
				this.cookie = value;
			}
		}

		public bool DownLoad
		{
			get{ return this.dwnLoad;}
			set
			{ 
				this.dwnLoad = value;
			}
		}

		public string Url
		{
			get{ return this.URL;}
			set
			{
				this.URL = value;
			}
		}

		public string Trigger
		{
			get{ return this.trigger;}
			set
			{ 
				this.trigger = value;
			}
		}
	}
}
