using System;
using System.Runtime.InteropServices;

namespace CustomBandObjectLib
{
	/// <summary>
	/// Summary description for IEEventsInterface.
	/// </summary>
	[Guid("34A715A0-6587-11D0-924A-0020AFC7AC4D"),
	InterfaceType(ComInterfaceType.InterfaceIsIDispatch)]
	public interface IMyWebBrowserEvents
	{
		[DispId(270)]
		void FileDownload(ref bool Cancel,ref bool Load);

		[DispId(250)]
		void BeforeNavigate2(object pDisp, ref object URL,
			ref object Flags, ref object TargetFrameName, ref object 
			PostData,
			ref object Headers, ref bool Cancel);

		[DispId(252)]
		void NavigateComplete2(object pDisp, ref object URL);

		[DispId(259)]
		void DocumentComplete(object pDisp, ref object URL);
	}

}
