using System;

namespace CustomBandObjectLib
{
    public class MyWebBrowser: SHDocVw.InternetExplorerClass	
    {
		public object Source;
		public object Sink;
		private ConnectionPointHelperClass pnt;
		private bool _advised = false;

        public MyWebBrowser():base()
        {
			Advise();
        }

		public void Advise()
		{
			Guid guid = typeof(SHDocVw.DWebBrowserEvents2).GUID;
			pnt = new ConnectionPointHelperClass(ref guid);
			Source = this;
			Sink = new IEEvents();
			pnt.Advise(ref Source, ref Sink);
			_advised = true;
		}

		public void Unadvise()
		{
			pnt.Unadvise();
			_advised = false;
		}

		public bool IsAdvised()
		{
			return _advised;
		}
	}
}