using System;
using Microsoft.Win32;
using System.Drawing;
using CustomBandObjectLib;
using System.Runtime.InteropServices;

namespace TorrentBar
{
	[Guid("9dadc22a-1eac-4a8e-be95-bbbead0f8c4d")]
	[BandObjectLib.BandObject("TorrentBar", BandObjectLib.BandObjectStyle.Horizontal, HelpText = "Ultimate Torrent Manager")]
	public class TorrentBar :  CustomBandObject
	{
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.TabPage tabPage2;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox textBox3;
		private System.Windows.Forms.TextBox textBox4;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.TextBox textBox5;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.ToolBarButton toolBarButton1;
		private System.Windows.Forms.ToolBarButton toolBarButton2;
		private System.Windows.Forms.ToolBarButton toolBarButton3;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.TextBox textBox6;
		private System.Windows.Forms.ColumnHeader columnHeader3;
		private System.Windows.Forms.TabPage tabPage3;
		private System.Windows.Forms.ContextMenu MainCTXMenu;
		private System.Windows.Forms.ContextMenu LogCTXMenu;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.ToolBarButton toolBarButton6;
		private myListView.myListView myListView1;
		private System.Windows.Forms.TabPage tabPage4;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.ToolBar toolBar2;
		private System.Windows.Forms.ToolBarButton toolBarButton5;
		private System.Windows.Forms.TextBox tbLog;
		private int ErrorCount = 1;
		

		public TorrentBar()
		{
			InitializeComponent();
			this.Title = "Torrent Bar v0.1.4BETA";
			this.ExplorerAttached += new EventHandler(TorrentBar_ExplorerAttached);
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if( components != null )
					components.Dispose();
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		private void InitializeComponent()
		{ 
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(TorrentBar));
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabPage1 = new System.Windows.Forms.TabPage();
			this.myListView1 = new myListView.myListView();
			this.MainCTXMenu = new System.Windows.Forms.ContextMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.toolBarButton1 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton2 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton3 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton6 = new System.Windows.Forms.ToolBarButton();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.tabPage2 = new System.Windows.Forms.TabPage();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.textBox6 = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.textBox5 = new System.Windows.Forms.TextBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.button1 = new System.Windows.Forms.Button();
			this.textBox4 = new System.Windows.Forms.TextBox();
			this.textBox3 = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.tabPage3 = new System.Windows.Forms.TabPage();
			this.LogCTXMenu = new System.Windows.Forms.ContextMenu();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.tbLog = new System.Windows.Forms.TextBox();
			this.tabPage4 = new System.Windows.Forms.TabPage();
			this.panel1 = new System.Windows.Forms.Panel();
			this.panel3 = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.toolBar2 = new System.Windows.Forms.ToolBar();
			this.toolBarButton5 = new System.Windows.Forms.ToolBarButton();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.tabControl1.SuspendLayout();
			this.tabPage1.SuspendLayout();
			this.tabPage2.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.tabPage3.SuspendLayout();
			this.tabPage4.SuspendLayout();
			this.panel1.SuspendLayout();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabPage1);
			this.tabControl1.Controls.Add(this.tabPage2);
			this.tabControl1.Controls.Add(this.tabPage3);
			this.tabControl1.Controls.Add(this.tabPage4);
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabControl1.Location = new System.Drawing.Point(-2, 0);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(748, 202);
			this.tabControl1.TabIndex = 0;
			// 
			// tabPage1
			// 
			this.tabPage1.Controls.Add(this.myListView1);
			this.tabPage1.Controls.Add(this.toolBar1);
			this.tabPage1.Location = new System.Drawing.Point(4, 22);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(740, 176);
			this.tabPage1.TabIndex = 0;
			this.tabPage1.Text = "Torrents";
			// 
			// myListView1
			// 
			this.myListView1.AllowColumnReorder = true;
			this.myListView1.AutoArrange = false;
			this.myListView1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.myListView1.ContextMenu = this.MainCTXMenu;
			this.myListView1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.myListView1.FullRowSelect = true;
			this.myListView1.GridLines = true;
			this.myListView1.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.myListView1.Location = new System.Drawing.Point(0, 25);
			this.myListView1.MultiSelect = false;
			this.myListView1.Name = "myListView1";
			this.myListView1.Size = new System.Drawing.Size(740, 151);
			this.myListView1.TabIndex = 1;
			this.myListView1.View = System.Windows.Forms.View.Details;
			// 
			// MainCTXMenu
			// 
			this.MainCTXMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2,
																					  this.menuItem3,
																					  this.menuItem4});
			this.menuItem1.Text = "Action";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "Start";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.Text = "Stop";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "Delete";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// toolBar1
			// 
			this.toolBar1.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.toolBarButton1,
																						this.toolBarButton2,
																						this.toolBarButton3,
																						this.toolBarButton6});
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imageList1;
			this.toolBar1.Location = new System.Drawing.Point(0, 0);
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(740, 25);
			this.toolBar1.TabIndex = 0;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// toolBarButton1
			// 
			this.toolBarButton1.ImageIndex = 1;
			this.toolBarButton1.Tag = "0";
			this.toolBarButton1.ToolTipText = "Start";
			// 
			// toolBarButton2
			// 
			this.toolBarButton2.ImageIndex = 0;
			this.toolBarButton2.Tag = "1";
			this.toolBarButton2.ToolTipText = "Stop";
			// 
			// toolBarButton3
			// 
			this.toolBarButton3.ImageIndex = 2;
			this.toolBarButton3.Tag = "2";
			this.toolBarButton3.ToolTipText = "Delete";
			// 
			// toolBarButton6
			// 
			this.toolBarButton6.ImageIndex = 4;
			this.toolBarButton6.Tag = "4";
			this.toolBarButton6.ToolTipText = "Refresh grid";
			// 
			// imageList1
			// 
			this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.imageList1.ImageSize = new System.Drawing.Size(13, 13);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// tabPage2
			// 
			this.tabPage2.Controls.Add(this.groupBox2);
			this.tabPage2.Controls.Add(this.groupBox1);
			this.tabPage2.Location = new System.Drawing.Point(4, 22);
			this.tabPage2.Name = "tabPage2";
			this.tabPage2.Size = new System.Drawing.Size(740, 176);
			this.tabPage2.TabIndex = 1;
			this.tabPage2.Text = "Settings";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.textBox6);
			this.groupBox2.Controls.Add(this.label5);
			this.groupBox2.Controls.Add(this.textBox5);
			this.groupBox2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.groupBox2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBox2.Location = new System.Drawing.Point(536, 0);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(204, 176);
			this.groupBox2.TabIndex = 5;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Other settings";
			// 
			// textBox6
			// 
			this.textBox6.Location = new System.Drawing.Point(16, 80);
			this.textBox6.Multiline = true;
			this.textBox6.Name = "textBox6";
			this.textBox6.Size = new System.Drawing.Size(240, 48);
			this.textBox6.TabIndex = 3;
			this.textBox6.Text = "";
			this.textBox6.Visible = false;
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(16, 24);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(100, 16);
			this.label5.TabIndex = 1;
			this.label5.Text = "Refresh";
			// 
			// textBox5
			// 
			this.textBox5.Location = new System.Drawing.Point(16, 40);
			this.textBox5.Name = "textBox5";
			this.textBox5.TabIndex = 0;
			this.textBox5.Text = "";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.button1);
			this.groupBox1.Controls.Add(this.textBox4);
			this.groupBox1.Controls.Add(this.textBox3);
			this.groupBox1.Controls.Add(this.label4);
			this.groupBox1.Controls.Add(this.label3);
			this.groupBox1.Controls.Add(this.textBox1);
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Controls.Add(this.textBox2);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Dock = System.Windows.Forms.DockStyle.Left;
			this.groupBox1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBox1.Location = new System.Drawing.Point(0, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(536, 176);
			this.groupBox1.TabIndex = 4;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Server settings";
			// 
			// button1
			// 
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.button1.Location = new System.Drawing.Point(432, 40);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(64, 20);
			this.button1.TabIndex = 8;
			this.button1.Text = "Save";
			this.button1.Click += new System.EventHandler(this.button1_Click_1);
			// 
			// textBox4
			// 
			this.textBox4.Location = new System.Drawing.Point(232, 80);
			this.textBox4.Name = "textBox4";
			this.textBox4.PasswordChar = '*';
			this.textBox4.Size = new System.Drawing.Size(192, 20);
			this.textBox4.TabIndex = 7;
			this.textBox4.Text = "";
			// 
			// textBox3
			// 
			this.textBox3.Location = new System.Drawing.Point(232, 40);
			this.textBox3.Name = "textBox3";
			this.textBox3.Size = new System.Drawing.Size(192, 20);
			this.textBox3.TabIndex = 6;
			this.textBox3.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(232, 64);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(100, 16);
			this.label4.TabIndex = 5;
			this.label4.Text = "Password";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(232, 24);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(100, 16);
			this.label3.TabIndex = 4;
			this.label3.Text = "Login";
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(16, 40);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(200, 20);
			this.textBox1.TabIndex = 1;
			this.textBox1.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(100, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "Port";
			// 
			// textBox2
			// 
			this.textBox2.Location = new System.Drawing.Point(16, 80);
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(200, 20);
			this.textBox2.TabIndex = 3;
			this.textBox2.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(100, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "Server";
			// 
			// tabPage3
			// 
			this.tabPage3.ContextMenu = this.LogCTXMenu;
			this.tabPage3.Controls.Add(this.tbLog);
			this.tabPage3.Location = new System.Drawing.Point(4, 22);
			this.tabPage3.Name = "tabPage3";
			this.tabPage3.Size = new System.Drawing.Size(740, 176);
			this.tabPage3.TabIndex = 2;
			this.tabPage3.Text = "Log";
			// 
			// LogCTXMenu
			// 
			this.LogCTXMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuItem6});
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 0;
			this.menuItem6.Text = "Clear log";
			this.menuItem6.Click += new System.EventHandler(this.menuItem6_Click);
			// 
			// tbLog
			// 
			this.tbLog.BackColor = System.Drawing.Color.White;
			this.tbLog.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.tbLog.ContextMenu = this.LogCTXMenu;
			this.tbLog.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tbLog.Location = new System.Drawing.Point(0, 0);
			this.tbLog.Multiline = true;
			this.tbLog.Name = "tbLog";
			this.tbLog.ReadOnly = true;
			this.tbLog.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.tbLog.Size = new System.Drawing.Size(740, 176);
			this.tbLog.TabIndex = 0;
			this.tbLog.Text = "";
			this.tbLog.WordWrap = false;
			// 
			// tabPage4
			// 
			this.tabPage4.Controls.Add(this.panel1);
			this.tabPage4.Location = new System.Drawing.Point(4, 22);
			this.tabPage4.Name = "tabPage4";
			this.tabPage4.Size = new System.Drawing.Size(740, 176);
			this.tabPage4.TabIndex = 3;
			this.tabPage4.Text = "Favorites";
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.panel3);
			this.panel1.Controls.Add(this.panel2);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.DockPadding.All = 5;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(740, 176);
			this.panel1.TabIndex = 0;
			// 
			// panel3
			// 
			this.panel3.AutoScroll = true;
			this.panel3.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel3.DockPadding.All = 5;
			this.panel3.Location = new System.Drawing.Point(5, 32);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(730, 139);
			this.panel3.TabIndex = 1;
			// 
			// panel2
			// 
			this.panel2.BackColor = System.Drawing.SystemColors.Control;
			this.panel2.Controls.Add(this.toolBar2);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel2.Location = new System.Drawing.Point(5, 5);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(730, 27);
			this.panel2.TabIndex = 0;
			// 
			// toolBar2
			// 
			this.toolBar2.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.toolBar2.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.toolBarButton5});
			this.toolBar2.ButtonSize = new System.Drawing.Size(20, 19);
			this.toolBar2.DropDownArrows = true;
			this.toolBar2.ImageList = this.imageList1;
			this.toolBar2.Location = new System.Drawing.Point(0, 0);
			this.toolBar2.Name = "toolBar2";
			this.toolBar2.ShowToolTips = true;
			this.toolBar2.Size = new System.Drawing.Size(730, 25);
			this.toolBar2.TabIndex = 2;
			this.toolBar2.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar2_ButtonClick);
			// 
			// toolBarButton5
			// 
			this.toolBarButton5.ImageIndex = 5;
			this.toolBarButton5.ToolTipText = "Save changes";
			// 
			// TorrentBar
			// 
			this.Controls.Add(this.tabControl1);
			this.DockPadding.Bottom = -2;
			this.DockPadding.Left = -2;
			this.DockPadding.Right = -2;
			this.Name = "TorrentBar";
			this.Size = new System.Drawing.Size(744, 200);
			this.tabControl1.ResumeLayout(false);
			this.tabPage1.ResumeLayout(false);
			this.tabPage2.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.tabPage3.ResumeLayout(false);
			this.tabPage4.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion


		private void TorrentBar_ExplorerAttached(object sender, EventArgs e)
		{
			this.XmlChangeEvent +=new XmlChangeDelegate(TorrentBar_XmlChangeEvent);
			LoadItems();
			oCommon.Logger.EntryWrittenEvent +=new LogEventHandler(Logger_EntryWrittenEvent);
		}

		private void TorrentBar_XmlChangeEvent(string xml) 
		{	
			try
			{
				myListView1.ReadXML(xml);
			}
			catch{}
		}

		private void button1_Click_1(object sender, System.EventArgs e)
		{
			RegistryKey key = Registry.LocalMachine.OpenSubKey( "Software\\TorrentBar",true );

			key.SetValue("Server",textBox1.Text);
			key.SetValue("Port",textBox2.Text);
			key.SetValue("Login",textBox3.Text);
			key.SetValue("Password",textBox4.Text);
			key.SetValue("Refresh",textBox5.Text);
			//key.SetValue("Triggers",textBox6.Text);
			//key.SetValue("EnableQuick",checkBox1.Checked);
		}

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			switch(int.Parse(e.Button.Tag.ToString()))
			{
				case 0: 
				case 1:  
				case 2: { if (myListView1.GetSelectedItem() != -1) {base.Action(int.Parse(e.Button.Tag.ToString()),myListView1.Items[myListView1.GetSelectedItem()].SubItems[myListView1.Columns.Count -2].Text);};break;}
				case 4: { base.Action(4, null) ;break;}
			}
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			if(myListView1.GetSelectedItem() != -1){
				base.Action(0, myListView1.Items[myListView1.GetSelectedItem()].SubItems[myListView1.Columns.Count -2].Text);
			}
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			if(myListView1.GetSelectedItem() != -1)
			{
				base.Action(1, myListView1.Items[myListView1.GetSelectedItem()].SubItems[myListView1.Columns.Count -2].Text);
			}
		}

		private void menuItem4_Click(object sender, System.EventArgs e)
		{
			if(myListView1.GetSelectedItem() != -1){
				base.Action(2, myListView1.Items[myListView1.GetSelectedItem()].SubItems[myListView1.Columns.Count -2].Text);
			}
		}

		private void menuItem6_Click(object sender, System.EventArgs e)
		{
			tbLog.Clear();
		}

		private void UpdateErrorCount(int count)
		{
			tabControl1.TabPages[2].Text = "Log (" + count.ToString() + ")";
		}

		private void SetToolTip(System.Windows.Forms.Control ctrl, string text)
		{
			System.Windows.Forms.ToolTip toolTip1 = new System.Windows.Forms.ToolTip();
			toolTip1.AutoPopDelay = 5000;
			toolTip1.InitialDelay = 500;
			toolTip1.ReshowDelay = 500;
			toolTip1.ShowAlways = true;
			toolTip1.SetToolTip(ctrl, text);
		}

		private void AddLabelItem()
		{
			System.Windows.Forms.Panel oPanel = new System.Windows.Forms.Panel();
			System.Windows.Forms.Label oLblAuth = new System.Windows.Forms.Label();
			System.Windows.Forms.Label oLblTransfer = new System.Windows.Forms.Label();
			System.Windows.Forms.Label oLblURL = new System.Windows.Forms.Label();
			System.Windows.Forms.Label oLblFav = new System.Windows.Forms.Label();
			System.Windows.Forms.Label oLblGo = new System.Windows.Forms.Label();
			oPanel.Height = 20;
			SetToolTip(oLblAuth,"Authorization");
			oLblAuth.FlatStyle = System.Windows.Forms.FlatStyle.System;
			oLblTransfer.FlatStyle = System.Windows.Forms.FlatStyle.System;
			oLblURL.FlatStyle = System.Windows.Forms.FlatStyle.System;
			oLblFav.FlatStyle = System.Windows.Forms.FlatStyle.System;
			oLblGo.FlatStyle = System.Windows.Forms.FlatStyle.System;
			oLblAuth.Left = 0;
			oLblAuth.Text = "A";
			oLblAuth.Width = 15;
			oLblAuth.Top = 2;
			SetToolTip(oLblTransfer,"Transfer");
			oLblTransfer.Text = "Transfer";
			oLblTransfer.Left = 20;
			oLblTransfer.Top = 2;
			oLblTransfer.Width = 40;
			oLblURL.Left = 65;
			oLblURL.Text = "URL";
			oLblURL.Top = 2;
			SetToolTip(oLblURL,"URL");
			oLblURL.Width = 350;
			oLblFav.Left = 420;
			oLblFav.Top = 2;
			oLblFav.Text = "Identifiers";
			SetToolTip(oLblFav,"Identifiers");
			oLblFav.Width = 350;
			oLblGo.Left = 780;
			oLblGo.Top = 2;
			oLblGo.Width = 30;
			oLblGo.Text =  "Go";
			SetToolTip(oLblGo,"Go to site");
			oPanel.Controls.Add(oLblAuth);
			oPanel.Controls.Add(oLblTransfer);
			oPanel.Controls.Add(oLblURL);
			oPanel.Controls.Add(oLblFav);
			oPanel.Controls.Add(oLblGo);
			oPanel.Tag = "FavLbl";
			oPanel.Dock = System.Windows.Forms.DockStyle.Top;
			oPanel.DockPadding.Bottom = 5;
			//oPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel3.Controls.Add(oPanel);			
		}
		
		private void AddItem(string cookie, string dwnLoad, string url, string trigger)
		{
			System.Windows.Forms.Panel oPanel = new System.Windows.Forms.Panel();
			System.Windows.Forms.CheckBox oCb = new System.Windows.Forms.CheckBox();
			System.Windows.Forms.RadioButton oRb1 = new System.Windows.Forms.RadioButton();
			System.Windows.Forms.RadioButton oRb2= new System.Windows.Forms.RadioButton();
			System.Windows.Forms.TextBox oTb1 = new System.Windows.Forms.TextBox();
			System.Windows.Forms.TextBox oTb2 = new System.Windows.Forms.TextBox();
			System.Windows.Forms.Button oBtn = new System.Windows.Forms.Button();
			oCb.FlatStyle = System.Windows.Forms.FlatStyle.System;
			oRb1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			oRb2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			oBtn.FlatStyle = System.Windows.Forms.FlatStyle.System;
			oPanel.Height = 20;
			SetToolTip(oCb,"Use cookie for authorization");
			oCb.Left = 0;
			oCb.Width = 15;
			SetToolTip(oRb1,"Download torrent and send to server");
			oRb1.Left = 20;
			oRb1.Width = 15;
			oRb2.Left = 40;
			SetToolTip(oRb2,"Send torrent URL to server");
			oRb2.Width = 15;
			oTb1.Left = 60;
			SetToolTip(oTb1,"URL to torrent site (format www.abc.123)");
			oTb1.Width = 350;
			oTb2.Left = 420;
			SetToolTip(oTb2,"Alternative torrent extensions to look for (ie .php, .aspx)");
			oTb2.Width = 350;
			oBtn.Left = 780;
			oBtn.Width = 30;
			oBtn.Text = "Go";
			oBtn.Height = 20;
			oBtn.FlatStyle = System.Windows.Forms.FlatStyle.System;
			oPanel.Controls.Add(oCb);
			oPanel.Controls.Add(oRb1);
			oPanel.Controls.Add(oRb2);
			oPanel.Controls.Add(oTb1);
			oPanel.Controls.Add(oTb2);
			if (url != "")
			{
				oPanel.Controls.Add(oBtn);
				oBtn.Click +=new EventHandler(oBtn_Click);
			}
			oBtn.Tag = url;
			if (cookie == "1")
			{
				oCb.Checked = true;
			}
			else
			{
				oCb.Checked = false;
			}
			if (dwnLoad == "1")
			{
				oRb1.Checked = true;
			}
			else
			{
				oRb2.Checked = true;
			}
			oTb1.Text = url;
			oTb2.Text = trigger;

			oPanel.Tag = "Fav";
			oPanel.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel3.Controls.Add(oPanel);
		
		}

		private void AddSpacer()
		{
			System.Windows.Forms.Panel oPanel = new System.Windows.Forms.Panel();
			oPanel.Height = 1;
			oPanel.Tag = "Spacer";
			oPanel.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel3.Controls.Add(oPanel);
		}

		private void LoadItems()
		{
			RegistryKey key = Registry.LocalMachine.OpenSubKey("Software\\TorrentBar" );

			if ( key != null ) 
			{
				textBox1.Text=key.GetValue("Server").ToString();
				textBox2.Text=key.GetValue("Port").ToString();
				textBox3.Text=key.GetValue("Login").ToString();
				textBox4.Text=key.GetValue("Password").ToString();
				textBox5.Text=key.GetValue("Refresh").ToString();
				//checkBox1.Checked=((bool)key.GetValue("EnableQuick"));
			}
			char[] sep = new char[1];
			sep[0] = ',';
			string favs = base.oCommon.Reg.GetFavorites();
			string[] aFavs = favs.Split(sep);
			panel3.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			for (int i = 0;i < aFavs.Length / 4; i++)
			{
				AddItem((string)aFavs[(i*4)],(string)aFavs[(i*4)+1],(string)aFavs[(i*4)+2],(string)aFavs[(i*4)+3]);
				AddSpacer();
			}
			AddItem("0","1","","");
			AddLabelItem();
		}

		private void toolBar2_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			string favs = "";
			foreach (System.Windows.Forms.Panel p in panel3.Controls)
			{
				if ((string)p.Tag == "Fav")
				{
					bool cookie = ((System.Windows.Forms.CheckBox)p.Controls[0]).Checked;
					bool dwnLoad = ((System.Windows.Forms.RadioButton)p.Controls[1]).Checked;
					string url = ((System.Windows.Forms.TextBox)p.Controls[3]).Text;
					string trigger = ((System.Windows.Forms.TextBox)p.Controls[4]).Text;
					

					if (url != string.Empty)
					{
						if (cookie == true)
						{
							favs = favs + "1,";
						}
						else
						{
							favs = favs + "0,";
						}

						
						if (dwnLoad == true)
						{
							favs = favs + "1,";
						}
						else
						{
							favs = favs + "0,";
						}

						if (url.StartsWith("http://"))
						{
							favs = favs + new Uri(url).Host +",";
						}
						else
						{
							favs = favs + new Uri("http://" + url).Host +",";
						}

						if (trigger.EndsWith(";"))
						{
							trigger = trigger.Remove(trigger.Length-1,1);
						}
						favs = favs + trigger +",";
					}
				}
			}
			
			favs = favs.Remove(favs.Length-1,1);
			this.oCommon.Reg.SetFavorites(favs);
			this.panel3.Controls.Clear();
			LoadItems();
			base.oCommon.FavHandler.LoadFavorites();
		}

		private void Logger_EntryWrittenEvent(object sender, LogEventArgs e)
		{
			System.Text.StringBuilder sb = new System.Text.StringBuilder(tbLog.Text);
			if (e.Type == Log.LogType.Error) { UpdateErrorCount(ErrorCount++);}
			sb.Append("<");
			sb.Append(DateTime.Now.ToShortTimeString() + " " + DateTime.Now.ToShortDateString());
			switch(e.Type)
			{
				case  Log.LogType.Error: sb.Append(" Error");break;
				case Log.LogType.Information: sb.Append(" Info");break;
			}
			sb.Append("> ");
			sb.Append(e.Message);
			sb.Append("\r\n");
			tbLog.Text = sb.ToString();
		}

		private void oBtn_Click(object sender, EventArgs e)
		{
			base.DoNavigate(((System.Windows.Forms.Button)sender).Tag);	
		}
	}
}
