using System;

namespace CustomBandObjectLib
{
	/// <summary>
	/// Summary description for ResponseObject.
	/// </summary>
	public class ResponseObject
	{
		private string _connectionID;
		private string _objectID;
		private string _dlm_objectID;
		private string _d_objectID;
		private string _tm_objectID;
		private string _td_objectID;
		private string _s_objectID;
		private string _list;
		private string _hash;
		private string _torrent_url;
		private string _torrent;
		private string _dl_objectID;

		public ResponseObject()
		{
		}

		public ResponseObject(String ConnectionID)
		{
			this._connectionID = ConnectionID;
		}

		public ResponseObject(String ConnectionID, String ObjectID)
		{
			this._connectionID = ConnectionID;
			this._objectID  = ObjectID;
		}

		public ResponseObject(String ConnectionID, String ObjectID, String list)
		{
			this.ConnectionID = ConnectionID;
			this.ObjectID  = ObjectID;
			this._list = list;
		}

		public String Hash
		{
			get{ return this._hash;}
			set{ this._hash = value;}
		}

		public string DLObjectID
		{
			get{ return this._dl_objectID;}
			set{ this._dl_objectID = value;}
		}

		
		public string Torrent
		{
			get{ return this._torrent;}
			set{ this._torrent = value;}
		}

		public String ConnectionID
		{
			get{ return this._connectionID;}
			set{ this._connectionID = value;}
		}

		public String ObjectID
		{
			get{ return this._objectID;}
			set{ this._objectID = value;}
		}

		public String DLMObjectID
		{
			get{ return this._dlm_objectID;}
			set{ this._dlm_objectID = value;}
		}

		public String TMObjectID
		{
			get{ return this._tm_objectID;}
			set{ this._tm_objectID = value;}
		}

		public String TDObjectID
		{
			get{ return this._td_objectID;}
			set{ this._td_objectID = value;}
		}
		
		public String SObjectID
		{
			get{ return this._s_objectID;}
			set{ this._s_objectID = value;}
		}

		public String DObjectID
		{
			get{ return this._d_objectID;}
			set{ this._d_objectID = value;}
		}

		
		public String TorrentURL
		{
			get{ return this._torrent_url;}
			set{ this._torrent_url = value;}
		}

		public String List
		{
			get{ return this._list;}
			set{ this._list = value;}
		}
	}
}
