using System;
using System.IO;

namespace CustomBandObjectLib
{
	/// <summary>
	/// Summary description for ResponseParser.
	/// </summary>
	public class ResponseParser
	{
		ResponseObject obj = null;

		public ResponseParser()
		{	
			obj = new ResponseObject();
		}

		public ResponseObject DoParse(ref Stream stream, Protocol.Commands command)
		{	
			obj.List = null;	
			XMLReader reader = new XMLReader(ref obj,ref stream, command);
			if (obj.List != null)
			{
				System.Text.StringBuilder   sb = new System.Text.StringBuilder();
				sb.Insert(0,"<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>");
				sb.Append("<LIST>");
				sb.Append(obj.List);
				sb.Append("</LIST>");
				obj.List = null;
				obj.List = sb.ToString();
			}
			
			
			return obj;
		}
	}
}
